EaBIM一直以来积极响应国家“十二五”推进建筑业信息化的号召,对建筑领域的信息技术开展深入技术交流和探讨!致力于打造“BIM-建筑师-生态技术”三位一体综合资源交流共享平台,希望为BIM与可持续设计理念及技术的普及做出微小的贡献!!!

EaBIM

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

搜索
查看: 629|回复: 0
打印 上一主题 下一主题

[实体对象] LINQ、Lambda、Delegate-实体过滤

[复制链接]

1514

主题

7465

帖子

1万

积分

admin

Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10

积分
12396

社区QQ达人

跳转到指定楼层
楼主
发表于 2014-1-8 14:59:08 | 只看该作者 回帖奖励 |倒序浏览 |阅读模式
Let us look at a cool AutoCAD .NET coding gadget in this post. It uses the cool modern LINQ technology to find some AutoCAD entities with a pretty complex filtering criteria, e.g. finding all circles with red or yellow color, with DASHED or DOT line type, on a unfrozen layer TEST, and having radiuses between 2.0 and 6.0 unit.
In the old days without the LINQ technology, this is a not so straightforward and actually an error prone task. We generally had to use many out-of-dated ADS stuffs such as result buffer, DXF codes, selection set, and different sets of relational and logical operators which are not familiar to C# or C++ programmers at all, though they have been wrapped a bit and renamed in the AutoCAD .NET as such, TypedValue, DxfCode, SelectionFilter, etc.
Furthermore, filtering color, layer and line type may be still possible to use the out of fashion result buffer and DXF code APIs, but for the circle radius comparison, a loop will be still necessary. Therefore, it just brings in unnecessary technical difficulties and makes the performance further worse if we choose to do so.
With the wonderful LINQ technology handy, we do not have to care about these unfriendly legacy stuffs anymore. We can make the same work done more nicely, naturally and efficiently with less code in a single loop using the LINQ technology. Here we go.


  1. private delegate bool InRange(double d);
  2. private static Entity cachedEntity = null;
  3. private static ObjectId cachedEntId = ObjectId.Null;
  4. private static Entity GetEnt(Transaction tr, ObjectId id)
  5. {
  6.     if (cachedEntId != id || cachedEntity == null)
  7.         cachedEntity = tr.GetObject(id, OpenMode.ForRead) as Entity;
  8.     return cachedEntity;
  9. }
  10. [CommandMethod("TestLinqInAutoCAD1")]
  11. public static void TestLinqInAutoCAD1_Method()
  12. {
  13.     Editor ed = MgdAcApplication.DocumentManager.MdiActiveDocument.Editor;
  14.     try
  15.     {
  16.         ObjectId[] ids;
  17.         InRange inRange2to6 = r => { return r >= 2.0 && r <= 6.0;};
  18.         using (Transaction tr = HostApplicationServices.WorkingDatabase.TransactionManager.StartTransaction())
  19.         {
  20.             BlockTable bt = tr.GetObject(HostApplicationServices.WorkingDatabase.BlockTableId, OpenMode.ForRead) as BlockTable;
  21.             BlockTableRecord btr = tr.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForRead) as BlockTableRecord;
  22.             var v = from ObjectId id in btr
  23.                     where GetEnt(tr, id) is Circle &&
  24.                             (new int[]{1,3}.Contains(GetEnt(tr, id).ColorIndex)) &&  //Color Red or Yellow
  25.                             GetEnt(tr, id).Layer == "TEST" &&                        //Layer 'TEST'
  26.                             !(tr.GetObject(GetEnt(tr, id).LayerId, OpenMode.ForRead) as LayerTableRecord).IsFrozen &&    //Layer not frozen
  27.                             (new string[]{"DASHED","DOT"}.Contains(GetEnt(tr, id).Linetype)) &&   //Linetype Dashed or Dotted
  28.                             inRange2to6((GetEnt(tr, id) as Circle).Radius) //Circle radius in the range [2.0, 6.0]
  29.                     select id;
  30.             ids = v.ToArray();
  31.             tr.Commit();
  32.         }
  33.         ed.WriteMessage(string.Format("\nThere are {0} circles meeting the filtering criteria.", ids.Length));
  34.     }
  35.     catch (System.Exception ex)
  36.     {
  37.         ed.WriteMessage(ex.ToString());
  38.     }
  39. }
复制代码
As can be seen, in the above succinct and cool code snippets, a few wonderful modern .NET technologies have been demonstrated such as LINQ, Lambda Expression and Delegate. Better, it is not just for new thing show-off. Instead, each cool tech applied here has its own very reason!
In case there are some circles meeting the filtering criteria in the current drawing, the command may print out something onto the AutoCAD command line window as follows:
Command: TestLinqInAutoCAD1
There are 58 circles meeting the filtering criteria.
Command: -LAYER
Current layer:  "TEST"
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]: lo
Enter name list of layer(s) to lock or <select objects>: TEST
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]:
Command: TESTLINQINAUTOCAD1
There are 58 circles meeting the filtering criteria.
Command: layer
Command: -LAYER
Current layer:  "TEST"
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]: s
Enter layer name to make current or <select object>: 0
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]: freeze
Enter name list of layer(s) to freeze or <select objects>: test
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]:
Command: TESTLINQINAUTOCAD1
There are 0 circles meeting the filtering criteria.
Command: -LAYER
Current layer:  "0"
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]: thaw
Enter name list of layer(s) to thaw: test
Enter an option
[?/Make/Set/New/Rename/ON/OFF/Color/Ltype/LWeight/TRansparency/MATerial/Plot/Fre
eze/Thaw/LOck/Unlock/stAte/Description/rEconcile]:
Command: TESTLINQINAUTOCAD1
There are 58 circles meeting the filtering criteria.
By the way, besides better code conciseness, cleanness, and readability in the code as demonstrated here, in terms of performance, I bet the new way is way better as well, though I haven’t done any experiment about it. If interested in, please feel free to go ahead and give it a shot.
Enjoy it! More coding gadgets will be created and demonstrated in the future. Please stay tuned.
The leading edge AutoCAD .NET Addin Wizard (AcadNetAddinWizard)provides various project wizards, item wizards, coders and widgets to help program AutoCAD .NET addins.

分享到:  QQ好友和群QQ好友和群 QQ空间QQ空间 腾讯微博腾讯微博 腾讯朋友腾讯朋友 微信微信
收藏收藏 转播转播 分享分享 分享淘帖 支持支持 反对反对
工作时间:工作日的9:00-12:00/13:30-18:00,节假日不在线,请勿留言
*滑块验证:
您需要登录后才可以回帖 登录 | 注册

本版积分规则

QQ|EaBIM网 ( 苏ICP备2020058923号-1  苏公网安备32011502011255号

GMT+8, 2024-9-28 10:18

Powered by Discuz! X3.2 Licensed

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表